-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
-- Nitrous Oxide BeamNG.drive 0.9.x Speed Booster by GameTapped.com aka MatchBox201
-- Do Not Remove Comments

local M = {}
local NOS = {}

local function init()
	gui.message("", 0, "^nitrous\\.")
	electrics.values.nitro = 0
    NOS.boosted = false
	NOS.default = 1.001
	NOS.boostcount = 100
	NOS.cheater = false
	--code from controller.lua
	local jbeamControllers = v.data.controller
	if not jbeamControllers then
		jbeamControllers = {{fileName = "dummy"}}
		log("D", "controller.init", "No controllers found for NOS, adding a dummy controller!")
	end

	for k, v in pairs(jbeamControllers) do
		if v.name == "nos" then
			print("NOS Controller Found" .. " increase=" ..v.boost_increase .. " tank volume=" ..v.tank_volume)
			NOS.increase = 1 + (v.boost_increase * 0.0005)
			NOS.boostcount = NOS.boostcount - 100 + v.tank_volume
			if NOS.boostcount > 200 then
			NOS.cheater = true
			end
		end
	end
	NOS.increase = NOS.increase or NOS.default
	NOS.drain =  0.04 * ((NOS.increase - 1) * 1000)

end


local function updateGFX(dt)
	if electrics.values.nitro == 1 and NOS.boostcount > 0 and not NOS.boosted then 
		NOS.boosted = true 
		powertrain.getDevice("mainEngine").outputAVState = NOS.increase
	elseif electrics.values.nitro == 0 and NOS.boosted then
		NOS.boosted = false
		powertrain.getDevice("mainEngine").outputAVState = 1
		gui.message("", 0, "^nitrous\\.")
	end

	if NOS.boosted == true then
		NOS.boostcount = NOS.boostcount - NOS.drain
		if NOS.cheater == true then
			NOS.boostcount = 201
		end
 		NOS.display = math.floor(NOS.boostcount+0.5)
		gui.message("Nitrous! " .. NOS.display .. "% Remaining", 0, "^nitrous\\.")
		
		--if electrics.values.lockupClutchRatio then --TCC lock for better improvements (experimental)
		--	electrics.values.lockupClutchRatio = 1
		--end
	end
end

-- public interface
M.updateGFX      = updateGFX
M.onInit      = init
M.onReset     = init

return M
																																																																																																																																																											                                                                                                                                